<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template match="/">
  <html>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE"/>  
  <head>
<BASE HREF="http://neimod.com/dstek/dstek2.xsl">

<style type="text/css">
.unnamed1 {
	border: 1px solid #FFFFFF;
	margin: 4px;
	padding: 0px 4px;

}
.unnamed2 {
	border: 4px solid #999999;
}
div.bitexpl { float: left;  }
.courierfont {
	font-family: "Courier New", Courier, mono;
}

.examplecode {
	font-family: "Courier New", Courier, mono;
	border: 1px dotted gray;
}

.overviewbittable {
	margin: 0;
	padding: 0;
	font-size: 5px;
}

</style>
</BASE>
  </head>

  <body>
<TABLE WIDTH="100%">
  <TR bgcolor="#cccccc">
    <TD><FONT SIZE="+6">DS Tek - Nintendo DS Technical Information</FONT></TD>
  </TR>
  <TR bgcolor="#cccccc">
    <TD style="text-align: right"><FONT>This document contains both information of my own (c) neimod and information of <a href="http://nocash.emubase.de/gbatek.htm">GBATek</a> (c) Martin Korth</FONT></TD>	
  </TR>
  <TR>
   <TD>
    <font color="RED">Got any additions?<br/>
     Send in anything related to DSTek to n.e.i.mod@h.ot.mai.l.com and remove the dots, except .com.
    </font>
   </TD>
  </TR>
</TABLE>
<p><xsl:text>&#160;</xsl:text></p>

<TABLE WIDTH="100%">
 <TR bgcolor="#cccccc"> 
  <TD><FONT SIZE="+2">Index</FONT></TD>
 </TR>
</TABLE>

<xsl:for-each select="dstek/section">
 <a href="#{@name}">
  <xsl:value-of select="@name"/><br/>
 </a>
</xsl:for-each>
<br/>
<br/>

<xsl:apply-templates/>

<TABLE WIDTH="100%">
 <TR bgcolor="#cccccc"> 
  <TD><FONT SIZE="+2">I/O Overview</FONT></TD>
 </TR>
</TABLE>

<TABLE class="overviewbittable" width="100%">
<CAPTION><font size="5">ARM9 I/O Registers</font></CAPTION>
<xsl:for-each select="//register[@arm9='true']">
<xsl:sort select="address"/>
 <xsl:variable name="size" select="size"/>
 <xsl:if test="count(@generic)=0">
  
   <TR class="overviewbittable"> 
    <TD class="overviewbittable"> 
     <font size="2"> <xsl:value-of select="translate(address, 'abcdefghijklmnopqrstuvwxyz', 'ABCDEFGHIJKLMNOPQRSTUVWxYZ')"/> </font>
    </TD>
    <TD class="overviewbittable">
     <font size="2"> REG_<xsl:value-of select="abbrev"/> 
     <xsl:if test="attrib">
      (<xsl:value-of select="attrib"/>)
     </xsl:if>
     </font>
    </TD>
    <TD>
     <TABLE class="overviewbittable" border="1" cellpadding="0" cellspacing="0" width="100%">
      <TR class="overviewbittable" bgcolor="#CCCCCC">
       <xsl:call-template name="makerow_bit_list">
        <xsl:with-param name="bit" select="$size*8 - 1"/>
       </xsl:call-template>
      </TR>
      <TR class="overviewbittable">
       <xsl:choose>
        <xsl:when test="//register[@arm9 and @generic='true' and abbrev=current()/abbrev]">
         <xsl:for-each select="//register[@arm9 and @generic='true' and abbrev=current()/abbrev]">
          <xsl:call-template name="makerow_bit_names">
           <xsl:with-param name="bit" select="$size*8 - 1"/>
          </xsl:call-template>
         </xsl:for-each>
        </xsl:when>
        <xsl:otherwise>
         <xsl:call-template name="makerow_bit_names">
          <xsl:with-param name="bit" select="$size*8 - 1"/>
         </xsl:call-template>     
        </xsl:otherwise>
       </xsl:choose>
      </TR>
     </TABLE>
    </TD>
   </TR>

 </xsl:if>
</xsl:for-each>
  </TABLE>

<TABLE class="overviewbittable" width="100%">
<CAPTION><font size="5">ARM7 I/O Registers</font></CAPTION>
<xsl:for-each select="//register[@arm7]">
<xsl:sort select="address"/>
 <xsl:variable name="size" select="size"/>
 <xsl:if test="count(@generic)=0">
  
   <TR class="overviewbittable"> 
    <TD class="overviewbittable"> 
     <font size="2"> <xsl:value-of select="translate(address, 'abcdefghijklmnopqrstuvwxyz', 'ABCDEFGHIJKLMNOPQRSTUVWxYZ')"/> </font>
    </TD>
    <TD class="overviewbittable">
     <font size="2"> REG_<xsl:value-of select="abbrev"/> 
     <xsl:if test="attrib">
      (<xsl:value-of select="attrib"/>)
     </xsl:if>
     </font>
    </TD>
    <TD>
     <TABLE class="overviewbittable" border="1" cellpadding="0" cellspacing="0" width="100%">
      <TR class="overviewbittable" bgcolor="#CCCCCC">
       <xsl:call-template name="makerow_bit_list">
        <xsl:with-param name="bit" select="$size*8 - 1"/>
       </xsl:call-template>
      </TR>
      <TR class="overviewbittable">
       <xsl:choose>
        <xsl:when test="//register[@arm7 and @generic='true' and abbrev=current()/abbrev]">
         <xsl:for-each select="//register[@arm7 and @generic='true' and abbrev=current()/abbrev]">
          <xsl:call-template name="makerow_bit_names">
           <xsl:with-param name="bit" select="$size*8 - 1"/>
          </xsl:call-template>
         </xsl:for-each>
        </xsl:when>
        <xsl:otherwise>
         <xsl:call-template name="makerow_bit_names">
          <xsl:with-param name="bit" select="$size*8 - 1"/>
         </xsl:call-template>     
        </xsl:otherwise>
       </xsl:choose>
      </TR>
     </TABLE>
    </TD>
   </TR>

 </xsl:if>
</xsl:for-each>
  </TABLE>

  </body>
  
<SCRIPT language="Javascript">
<!--

// FILE ARCHIVED ON 20071026135415 AND RETRIEVED FROM THE
// INTERNET ARCHIVE ON 20080804015539.
// JAVASCRIPT APPENDED BY WAYBACK MACHINE, COPYRIGHT INTERNET ARCHIVE.
// ALL OTHER CONTENT MAY ALSO BE PROTECTED BY COPYRIGHT (17 U.S.C.
// SECTION 108(a)(3)).

   var sWayBackCGI = "http://web.archive.org/web/20071026135415/";

   function xResolveUrl(url) {
      var image = new Image();
      image.src = url;
      return image.src;
   }
   function xLateUrl(aCollection, sProp) {
      var i = 0;
      for(i = 0; i < aCollection.length; i++) {
         if (typeof(aCollection[i][sProp]) == "string") { 
          if (aCollection[i][sProp].indexOf("mailto:") == -1 &&
             aCollection[i][sProp].indexOf("javascript:") == -1) {
            if(aCollection[i][sProp].indexOf("http") == 0) {
                aCollection[i][sProp] = sWayBackCGI + aCollection[i][sProp];
            } else {
                aCollection[i][sProp] = sWayBackCGI + xResolveUrl(aCollection[i][sProp]);
            }
         }
         }
      }
   }

   xLateUrl(document.getElementsByTagName("IMG"),"src");
   xLateUrl(document.getElementsByTagName("A"),"href");
   xLateUrl(document.getElementsByTagName("AREA"),"href");
   xLateUrl(document.getElementsByTagName("OBJECT"),"codebase");
   xLateUrl(document.getElementsByTagName("OBJECT"),"data");
   xLateUrl(document.getElementsByTagName("APPLET"),"codebase");
   xLateUrl(document.getElementsByTagName("APPLET"),"archive");
   xLateUrl(document.getElementsByTagName("EMBED"),"src");
   xLateUrl(document.getElementsByTagName("BODY"),"background");
   var forms = document.getElementsByTagName("FORM");
   if (forms) {
       var j = 0;
       for (j = 0; j < forms.length; j++) {
              f = forms[j];
              if (typeof(f.action)  == "string") {
                 if(typeof(f.method)  == "string") {
                     if(typeof(f.method) != "post") {
                        f.action = sWayBackCGI + f.action;
                     }
                  }
              }
        }
    }


//-->
</SCRIPT>

</html>
</xsl:template>


<xsl:template match="tr">
<TR>
 <xsl:apply-templates/>
</TR>
</xsl:template>

<xsl:template match="td">
<TD>
 <xsl:if test="@colspan">
  <xsl:attribute name="colspan"><xsl:value-of select="@colspan"/></xsl:attribute>
 </xsl:if>
 <xsl:apply-templates/>
</TD>
</xsl:template>

<xsl:template match="div">
<DIV>
 <xsl:if test="@class">
  <xsl:attribute name="class"><xsl:value-of select="@class"/></xsl:attribute>
 </xsl:if>
 <xsl:apply-templates/>
</DIV>
</xsl:template>

<xsl:template match="pre">
<PRE>
 <xsl:apply-templates/>
</PRE>
</xsl:template>

<xsl:template match="strong">
<STRONG>
 <xsl:apply-templates/>
</STRONG>
</xsl:template>

<xsl:template match="table">
<TABLE>
 <xsl:if test="@border">
  <xsl:attribute name="border"><xsl:value-of select="@border"/></xsl:attribute>
 </xsl:if>

 <xsl:if test="@align">
  <xsl:attribute name="align"><xsl:value-of select="@align"/></xsl:attribute>
 </xsl:if>

 <xsl:if test="@class">
  <xsl:attribute name="class"><xsl:value-of select="@class"/></xsl:attribute>
 </xsl:if>

 <xsl:if test="@cellspacing">
  <xsl:attribute name="cellspacing"><xsl:value-of select="@cellspacing"/></xsl:attribute>
 </xsl:if>

 <xsl:if test="@cellpadding">
  <xsl:attribute name="cellpadding"><xsl:value-of select="@cellpadding"/></xsl:attribute>
 </xsl:if>


 <xsl:apply-templates/>
</TABLE>
</xsl:template>

<xsl:template match="sup">
<SUP>
 <xsl:apply-templates/>
</SUP>
</xsl:template>

<xsl:template match="br">
 <br/>
</xsl:template>

<xsl:template match="img">
 <IMG>
 <xsl:if test="@src">
  <xsl:attribute name="src"><xsl:value-of select="@src"/></xsl:attribute>
 </xsl:if>

 <xsl:if test="@alt">
  <xsl:attribute name="alt"><xsl:value-of select="@alt"/></xsl:attribute>
 </xsl:if>
 </IMG>

</xsl:template>

<xsl:template match="a">
 <A>
 <xsl:if test="@href">
  <xsl:attribute name="href"><xsl:value-of select="@href"/></xsl:attribute>
 </xsl:if>

 <xsl:value-of select="."/>
 </A>

</xsl:template>


<xsl:template match="section">
<a name="{@name}"/>
<TABLE WIDTH="100%">
 <TR bgcolor="#cccccc">
  <TD>
   <FONT SIZE="+2"><xsl:value-of select="@name"/></FONT>
  </TD>
 </TR>
</TABLE>
<BR/>

 <xsl:apply-templates/>
</xsl:template>

<xsl:template match="expl">
 <xsl:apply-templates/>
</xsl:template>

<xsl:template match="registerset">

<!--
<table class="unnamed2" width="100%" border="4" cellpadding="0" cellspacing="0">
 <tr class="unnamed2"> 
  <td nowrap="nowrap" bgcolor="#999999" class="unnamed2">
    <strong><font size="4"><xsl:value-of select="@name"/></font></strong>
  </td>
 </tr>
 <tr bgcolor="#FFFFFF"> 
  <td nowrap="nowrap" class="unnamed1">
-->

   <xsl:apply-templates/>
<br/>
<!--
  </td>
 </tr>
</table>
-->
</xsl:template>

<xsl:template match="register">
 <xsl:variable name="arm9" select="@arm9"/>
 <xsl:variable name="arm7" select="@arm7"/>
 <xsl:choose>

  <xsl:when test="@generic">
  <table border="0" class="courierfont" cellspacing="0" cellpadding="0">
   <tr>
    <td>Cpu&#160;</td>
    <td>Bit</td>
    <td>Name</td>
    <td>Expl.</td>
   </tr>
   <xsl:for-each select="bits/bit">
    <tr>
     <td valign="top" nowrap="nowrap">
      <xsl:choose>
       <xsl:when test="$arm9 and $arm7">
        9/7
       </xsl:when>
       <xsl:when test="$arm9">
        9
       </xsl:when>
       <xsl:otherwise>
        7
       </xsl:otherwise>
      </xsl:choose>
     </td>
     <td valign="top" nowrap="nowrap">
      <xsl:choose>
       <xsl:when test="@length = 1">
        <xsl:value-of select="@start"/>
        <xsl:text>&#160;&#160;&#160;</xsl:text>
       </xsl:when>
       <xsl:otherwise>
        <xsl:value-of select="@start"/>-<xsl:value-of select="@start + @length - 1"/>
        <xsl:text>&#160;&#160;&#160;</xsl:text>
       </xsl:otherwise>
      </xsl:choose>
     </td>
     <td valign="top" nowrap="nowrap">
      <xsl:value-of select="name"/>
      <xsl:text>&#160;&#160;</xsl:text>
     </td>
     <td valign="top" nowrap="nowrap">
<!--
       <xsl:value-of select="expl"/>
-->
      <xsl:apply-templates select="expl"/>
     </td>
     <td valign="top" width="100%">
      <xsl:text>&#160;</xsl:text>
     </td>
    </tr>
   </xsl:for-each>
  </table>
  </xsl:when>

  <xsl:otherwise>
   <strong>
    <xsl:value-of select="translate(address, 'abcdefghijklmnopqrstuvwxyz', 'ABCDEFGHIJKLMNOPQRSTUVWxYZ')"/> - REG_<xsl:value-of select="abbrev"/> - <xsl:value-of select="name"/>
    <xsl:if test="attrib">
     (<xsl:value-of select="attrib"/>)
    </xsl:if>
   </strong>
   <xsl:if test="bits">
    <table border="0" class="courierfont" cellspacing="0" cellpadding="0">
     <tr>
      <td>Cpu&#160;</td>
      <td>Bit</td>
      <td>Name</td>
      <td>Expl.</td>
     </tr>
     <xsl:for-each select="bits/bit">
      <tr>
       <td valign="top" nowrap="nowrap">
        <xsl:choose>
         <xsl:when test="$arm9 and $arm7">
          9/7
         </xsl:when>
         <xsl:when test="$arm9">
          9
         </xsl:when>
         <xsl:otherwise>
          7
         </xsl:otherwise>
        </xsl:choose>
       </td>
       <td valign="top" nowrap="nowrap">
        <xsl:choose>
         <xsl:when test="@length = 1">
          <xsl:value-of select="@start"/>
          <xsl:text>&#160;&#160;&#160;</xsl:text>
         </xsl:when>
         <xsl:otherwise>
          <xsl:value-of select="@start"/>-<xsl:value-of select="@start + @length - 1"/>
          <xsl:text>&#160;&#160;&#160;</xsl:text>
         </xsl:otherwise>
        </xsl:choose>
       </td>
       <td valign="top" nowrap="nowrap">
        <xsl:value-of select="name"/>
        <xsl:text>&#160;&#160;</xsl:text>
       </td>
     <td valign="top" nowrap="nowrap">
<!--
       <xsl:value-of select="expl"/>
-->
      <xsl:apply-templates select="expl"/>
     </td>
       <td width="100%">
        <xsl:text>&#160;</xsl:text>
       </td>
      </tr>
     </xsl:for-each>
    </table>
   </xsl:if>
  </xsl:otherwise>

 </xsl:choose>

<br/>

<!--
   <table class="unnamed1" width="100%" border="1" cellpadding="0" cellspacing="0" bordercolor="#FFFFFF" bgcolor="#FFFFFF">
     <tr class="unnamed1"  bordercolor="#FFFFFF" bgcolor="#CCCCCC"> 
      <td class="unnamed1" nowrap="nowrap">NAME</td>
      <td class="unnamed1" nowrap="nowrap">ADDRESS</td>
      <td class="unnamed1" nowrap="nowrap">ARM9</td>
      <td class="unnamed1" nowrap="nowrap">ARM7</td>
      <td class="unnamed1" nowrap="nowrap">SIZE</td>
      <xsl:if test="count(attributes) = 1">
      <td class="unnamed1" nowrap="nowrap">ATTRIBUTES</td>
      </xsl:if>
      <td class="unnamed1" nowrap="nowrap" width="100%">NOTES</td>
     </tr>
     <tr bordercolor="#FFFFFF" bgcolor="#EFEFEF"> 
      <td nowrap="nowrap" class="unnamed1">
       <xsl:value-of select="name"/>
      </td>
      <td nowrap="nowrap" class="unnamed1">
       <xsl:value-of select="address"/>
      </td>
      <td nowrap="nowrap" class="unnamed1"> 
       <xsl:call-template name="makecheckbox">
        <xsl:with-param name="checked" select="@arm9"/>
       </xsl:call-template>
      </td>
      <td nowrap="nowrap" class="unnamed1">
       <xsl:call-template name="makecheckbox">
        <xsl:with-param name="checked" select="@arm7"/>
       </xsl:call-template>
      </td>
      <td nowrap="nowrap" class="unnamed1">
       <div align="center">
        <xsl:value-of select="size*8"/>bits
       </div>
      </td>
      <xsl:if test="count(attributes) = 1">
      <td nowrap="nowrap" class="unnamed1">
       <div align="center">
        <xsl:value-of select="attributes"/>
       </div>
      </td>
      </xsl:if>

      <td nowrap="nowrap" class="unnamed1">
      <xsl:choose>
       <xsl:when test="count(note) = 1">
        <xsl:value-of select="note"/>
       </xsl:when>
       <xsl:otherwise>
       <xsl:text>&#160;</xsl:text>
       </xsl:otherwise>
      </xsl:choose>
      </td>
     
     </tr>
    </table>
-->

</xsl:template>

<!--

<xsl:template match="registerlist">
<xsl:variable name="abc" select="concat(register/size,'+aa')"/>
<table class="unnamed2" width="100%" border="4" cellpadding="0" cellspacing="0">
 <tr class="unnamed2"> 
  <td nowrap="nowrap" bgcolor="#999999" class="unnamed2">
    <strong><font size="4"><xsl:value-of select="@name"/></font></strong>
  </td>
 </tr>
 <tr bgcolor="#FFFFFF"> 
  <td nowrap="nowrap" class="unnamed1">

   <xsl:for-each select="register">

    <table class="unnamed1" width="100%" border="1" cellpadding="0" cellspacing="0" bordercolor="#FFFFFF" bgcolor="#FFFFFF">
     <tr class="unnamed1"  bordercolor="#FFFFFF" bgcolor="#CCCCCC"> 
      <td class="unnamed1" nowrap="nowrap">NAME</td>
      <td class="unnamed1" nowrap="nowrap">ADDRESS</td>
      <td class="unnamed1" nowrap="nowrap">ARM9</td>
      <td class="unnamed1" nowrap="nowrap">ARM7</td>
      <td class="unnamed1" nowrap="nowrap">SIZE</td>
      <xsl:if test="count(attributes) = 1">
      <td class="unnamed1" nowrap="nowrap">ATTRIBUTES</td>
      </xsl:if>
      <td class="unnamed1" nowrap="nowrap" width="100%">NOTES</td>
     </tr>
     <tr bordercolor="#FFFFFF" bgcolor="#EFEFEF"> 
      <td nowrap="nowrap" class="unnamed1">
       <xsl:value-of select="name"/>
      </td>
      <td nowrap="nowrap" class="unnamed1">
       <xsl:value-of select="address"/>
      </td>
      <td nowrap="nowrap" class="unnamed1"> 
       <xsl:call-template name="makecheckbox">
        <xsl:with-param name="checked" select="@arm9"/>
       </xsl:call-template>
      </td>
      <td nowrap="nowrap" class="unnamed1">
       <xsl:call-template name="makecheckbox">
        <xsl:with-param name="checked" select="@arm7"/>
       </xsl:call-template>
      </td>
      <td nowrap="nowrap" class="unnamed1">
       <div align="center">
        <xsl:value-of select="size*8"/>bits
       </div>
      </td>
      <xsl:if test="count(attributes) = 1">
      <td nowrap="nowrap" class="unnamed1">
       <div align="center">
        <xsl:value-of select="attributes"/>
       </div>
      </td>
      </xsl:if>

      <td nowrap="nowrap" class="unnamed1">
      <xsl:choose>
       <xsl:when test="count(note) = 1">
        <xsl:value-of select="note"/>
       </xsl:when>
       <xsl:otherwise>
       <xsl:text>&#160;</xsl:text>
       </xsl:otherwise>
      </xsl:choose>
      </td>
     
     </tr>
    </table>

    <xsl:if test="count(bits) > 0">
     <xsl:call-template name="makebittable"/>
      <table class="unnamed1" width="100%" border="1" cellpadding="0" cellspacing="0" bordercolor="#FFFFFF" bgcolor="#FFFFFF">
       <tr bordercolor="#FFFFFF" bgcolor="#99CCFF" class="unnamed1"> 
        <td   nowrap="nowrap" bgcolor="#CCCCCC" class="unnamed1">
         BIT
        </td>
        <td   nowrap="nowrap" bgcolor="#CCCCCC" class="unnamed1">
         NAME
        </td>
        <td   nowrap="nowrap" bgcolor="#CCCCCC" class="unnamed1">
         EXPL.
        </td>
       </tr>
<xsl:for-each select="bits/bit">
<xsl:sort select="@start"/>
<tr nowrap="nowrap" class="unnamed1">
<td nowrap="nowrap" class="unnamed1" bgcolor="#EFEFEF">
 <xsl:choose>
  <xsl:when test="@length = 1">
<xsl:value-of select="@start"/>
  </xsl:when>
  <xsl:otherwise>
<xsl:value-of select="@start"/>-<xsl:value-of select="@start + @length - 1"/>
  </xsl:otherwise>
 </xsl:choose>
</td>
<td nowrap="nowrap" class="unnamed1" bgcolor="#EFEFEF">
<xsl:value-of select="@name"/>
</td>
<td nowrap="nowrap" class="unnamed1" bgcolor="#EFEFEF">
<xsl:value-of select="."/>
</td>
</tr>
</xsl:for-each>

</table>
    </xsl:if>

   </xsl:for-each>

  <table>
  <tr> 
  <td>
<pre>
   <xsl:value-of select="info"/>
</pre>
  </td>
  </tr>
  </table>

  </td>
 </tr>
</table>

</xsl:template>

-->

<xsl:template name="makecheckbox">
 <xsl:param name="checked"/>

 <xsl:choose>
  <xsl:when test="$checked = 'true'">
   <div align="center"> 
    <input name="checkbox" type="checkbox" disabled="disabled" value="checkbox" checked="checked"/>
   </div>
  </xsl:when>
  <xsl:otherwise>
   <div align="center"> 
    <input name="checkbox" type="checkbox" disabled="disabled" value="checkbox" unchecked="unchecked"/>
   </div>
  </xsl:otherwise>
 </xsl:choose>

</xsl:template>

<xsl:template name="makebittable">

<table class="unnamed1" width="100%" border="1" cellpadding="0" cellspacing="0" bordercolor="#FFFFFF" bgcolor="#FFFFFF">
 <tr  bordercolor="#FFFFFF" bgcolor="#CCCCCC" class="unnamed1"> 
  <td  nowrap="nowrap" class="unnamed1">BIT
  </td>
  <xsl:call-template name="makerow_bit_list">
    <xsl:with-param name="size" select="size*8 - 1"/>
  </xsl:call-template>
 </tr>

 <tr bordercolor="#FFFFFF"> 
  <td nowrap="nowrap" bgcolor="#CCCCCC" class="unnamed1">
   ATTRIBUTES
  </td>
  <xsl:call-template name="makerow_bit_attributes">
    <xsl:with-param name="bit" select="size*8 - 1"/>
  </xsl:call-template>
  </tr>

  <tr bordercolor="#FFFFFF"> 
   <td nowrap="nowrap" bgcolor="#CCCCCC" class="unnamed1">
    DESCRIPTION
   </td>
  <xsl:call-template name="makerow_bit_names">
    <xsl:with-param name="bit" select="size*8 - 1"/>
  </xsl:call-template>
  </tr>


 </table>

 <br/>

</xsl:template>


<xsl:template name="makerow_bit_list">
<xsl:param name="bit" />

 <xsl:if test="$bit >= 0">
  <td class="overviewbittable">
   <div align="center">
    <font size="1"> <xsl:value-of select="$bit"/> </font>
   </div>
  </td> 
  <xsl:call-template name="makerow_bit_list">
   <xsl:with-param name="bit" select="$bit - 1"/>
  </xsl:call-template>
 </xsl:if>

</xsl:template>


<xsl:template name="makerow_bit_names">
 <xsl:param name="bit" />
  <xsl:variable name="bitstart" select="bits/bit[@start + @length - 1 = $bit]/@start"/>
  <xsl:variable name="bitlength" select="bits/bit[@start + @length - 1 = $bit]/@length"/>

 <xsl:choose>
  <xsl:when test="count(bits/bit[@start + @length - 1 = $bit]) = 0">
   <td bgcolor="#CCCCCC" class="overviewbittable">
    <font size="1"> <xsl:text>&#160;</xsl:text> </font>
   </td>

   <xsl:if test="$bit > 0">
    <xsl:call-template name="makerow_bit_names">
      <xsl:with-param name="bit" select="$bit - 1"/>
    </xsl:call-template>
   </xsl:if>
  </xsl:when>
  <xsl:otherwise>

   <td bgcolor="#FFFFFF" colspan="{bits/bit[@start + @length - 1 = $bit]/@length}" class="overviewbittable">
   <div align="center">
     <font size="1"> <xsl:value-of select="bits/bit[@start + @length - 1 = $bit]/abbrev"/> </font>
   </div>
   </td>

    <xsl:if test="$bit - $bitlength >= 0">
      <xsl:call-template name="makerow_bit_names">
        <xsl:with-param name="bit" select="bits/bit[@start + @length - 1 = $bit]/@start - 1"/>
      </xsl:call-template>
    </xsl:if>
  </xsl:otherwise>
</xsl:choose>
</xsl:template>

<xsl:template name="makerow_bit_attributes">
  <xsl:param name="bit" />
<xsl:choose>
  <xsl:when test="count(bits/bit[@start + @length - 1 = $bit]) = 0">
   <td nowrap="nowrap" bgcolor="#EFEFEF" class="unnamed1">
    <xsl:text>&#160;</xsl:text>
   </td>
   <xsl:if test="$bit > 0">
    <xsl:call-template name="makerow_bit_attributes">
      <xsl:with-param name="bit" select="$bit - 1"/>
    </xsl:call-template>
   </xsl:if>
  </xsl:when>
  <xsl:otherwise>

   <td colspan="{bits/bit[@start + @length - 1 = $bit]/@length}" nowrap="nowrap" bgcolor="#FFFFFF" class="unnamed1">
    <div align="center">
     <xsl:value-of select="bits/bit[@start + @length - 1 = $bit]/@attrib"/>
    </div>
   </td>
    <xsl:if test="$bit > 0">
      <xsl:call-template name="makerow_bit_attributes">
        <xsl:with-param name="bit" select="bits/bit[@start + @length - 1 = $bit]/@start - 1"/>
      </xsl:call-template>
    </xsl:if>
  </xsl:otherwise>
</xsl:choose>
</xsl:template>


</xsl:stylesheet> 
